with Ada.Numerics.Discrete_Random;
with Ada.Numerics.Float_Random;
use Ada.Numerics;
--with Text_Io;

with Gnat.Sockets;
use Gnat.Sockets;

with Ada.Strings.Fixed;
use Ada.Strings;
package body Warborg.Norad is
   
   
   
   type Algorithm_Access is access function (Charge_Max : in Float; Missiles_Max : in Positive; Side : in Side_Type) return Weapon_Manager.Vector;
   
   --  package Genetic_Search is
   --     function Random_Ant_Searching(Charge_Max : in Float; Missiles_Max : in Positive; Side : in Side_Type) return Weapon_Manager.Vector;
   --  end Genetic_Search;
   
   --  package body Genetic_Search is                      
      
      

   --     function Random_Ant_Searching(Charge_Max : in Float; Missiles_Max : in Positive ; Side : in Side_Type) return Weapon_Manager.Vector is
	 	 
   --  	 Targets : Weapon_Manager.Vector;	 
   --     begin	 	 
   --  	 return Targets;
   --     end Random_Ant_Searching;      
   --  end Genetic_Search;
   
   
   package Linear_Search is
      function Linear_Searching(Charge_Max : in Float; Missiles_Max : in Positive; Side : in Side_Type) return Weapon_Manager.Vector;
   end Linear_Search;
   
   package body Linear_Search is
      
      
      
      package Bool_Random is new Ada.Numerics.Discrete_Random(Boolean);   
      use Float_Random;

      
      package GPS_Coordonates_Manager is new Ada.Containers.Vectors(Positive, Gps_Coordonates_Type, "=");
      use GPS_Coordonates_Manager;
      
      Ray : constant Float := 6367.4445;
      
         function Solid_List (Side : in Side_Type;
			Ray : in Float;
			Distance : in Float) return GPS_Coordonates_Manager.Vector is
      
      Terra : GPS_Coordonates_Manager.Vector;
      Diametre : constant Float := Ray * 2.0;   
      Perimetre : constant Float := ((Pi * Diametre) / 1.852);
      D : constant Float := (1.0/60.0) * Distance * 2.0;
      
      Count_Of_Equator : constant Long_Long_integer := Long_Long_integer((Perimetre/Distance));
      
      Y : Decimal_Latitude_Type := -90.0 + D /2.0;
      X : Decimal_Longitude_Type := 0.0+ D / 2.0;            
   begin 
      --Text_Io.Put_Line("D =" & Float'Image(D));
      --Text_Io.Put_Line("count_of_equator =" & Long_Long_integer'Image(Count_Of_equator));	       	       	       
      
      case Side is	 
	 when Ouest =>
	North_est :
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..Count_Of_Equator/2 loop
		  for K in 1..I loop
		     for L in  1..J*2 loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      --Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit North_Est when X + D > 180.0;
			X := X + D;
			
		     end loop;	 	 

		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     X := 0.0 + D/2.0;  	 	 
		     exit when Y + D > 0.0;
		     Y := Y + D;						

		     
		  end loop;
	       end loop;      
	    end loop North_est;
	    X := 0.0 + D/2.0;  	 	 
	    Y := 90.0 - D/2.0;
	South_Est :
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..Count_Of_Equator/2 loop
		  for K in 1..I loop
		     for L in  1..J*2 loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      --Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit South_Est when X + D > 180.0;
			X := X + D;
			
		     end loop;	 	 
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		  X := 0.0 + D/2.0;  	 	 
		  exit when Y - D < 0.0;
		  Y := Y - D;						
		  

		     
		  end loop;
		  		  
	       end loop;      
	    end loop South_Est;
	    
	    
	    
	    
	    
	 when Est =>	  	      
	    X := 0.0 - D/ 2.0;            
	North_West :
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..Count_Of_Equator/2 loop
		  for K in 1..I loop
		     for L in  1..J*2 loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      --Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit when X - D < -180.0;
			X := X - D;
			
		     end loop;	 	 
		     
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     
		     X := 0.0 - D/2.0;  	 	 
		     exit North_west when Y + D > 0.0;
		     Y := Y + D;		
		     
		  end loop;
		  
	       end loop;      
	    end loop North_west;	       
	    X := -0.0 + D/ 2.0;            
	    Y := 90.0 - D/2.0;
	South_west:
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..Count_Of_Equator/2 loop
		  for K in 1..I loop
		     for L in  1..J*2 loop	    	    
			
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      --Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit South_West when X - D < -180.0;
			X := X - D;
			
		     end loop;	 	 
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     X := 0.0 - D/2.0;  	 	 
		     exit when Y - D < 0.0;
		     Y := Y - D;						

		  end loop;

	       end loop;      
	    end loop South_west;	       

	    
      end case;
      
      
      return Terra;     
   end Solid_List;   
   
      
      Old_Charge : float := 0.0;
      
      
      Position_Gen : Generator;
      
      use Weapon_Manager;
      
      Last_Index : positive := 1;
      
      
      Terra : GPS_Coordonates_Manager.Vector;
      
      Bool_Gen : Bool_Random.Generator;
      
      function Linear_Searching(Charge_Max : in Float; Missiles_Max : in Positive; Side : in Side_Type) return Weapon_Manager.Vector is
	 
	 Targets : Weapon_Manager.Vector;
	 
      begin
	 if Old_Charge /= Charge_Max then
	    Old_Charge := Charge_Max;
	    terra := Solid_list(side, Ray, Charge_Max);
	    --Text_Io.Put("Terra lenght : " & Natural'Image(GPS_Coordonates_Manager.Last_Index(Terra)));
	 end if;
	 if Last_Index + Missiles_Max > Gps_Coordonates_Manager.Last_Index(Terra) then
	    Last_Index := 1;
	 end if;
	 Reset(Position_Gen);
	 Bool_Random.Reset(Bool_Gen);	 	 
	 for I in Last_Index..Last_Index+Missiles_Max loop	    
	    
	    declare
	       Gps : constant Gps_Coordonates_Type := GPS_Coordonates_Manager.Element(Terra, I);
	       Missile : Missile_Type;
	    begin
	       case Side is
		  
		  when Ouest =>
		     
		     if Bool_Random.Random(Bool_Gen) then
			Missile.Position := To_Gps(Random(Position_Gen) * (-180.0), Random(Position_Gen) * (-90.0));
		     else
			Missile.Position := To_Gps(Random(Position_Gen) * (-180.0), Random(Position_Gen) * (90.0));
		     end if;
		     
		     Missile.Target := GPS;
			
		     when Est =>
			
			if Bool_Random.Random(Bool_Gen) then
			   Missile.Position := To_Gps(Random(Position_Gen) * 180.0, Random(Position_Gen) * (-90.0));
			else
			   Missile.Position := To_Gps(Random(Position_Gen) * 180.0, Random(Position_Gen) * (90.0));
			end if;
			
			Missile.Target := GPS;
			
		  end case;

		  Missile.charge := Charge_type(Charge_Max);
		  
		  
		  Targets := Targets & Missile;
	       end;	 	 
	    
	 end loop;
	 Last_Index := Last_Index + Missiles_Max;
	 return Targets;
      end Linear_Searching;      
   end Linear_Search;
   
   
   
   package Random_Search is
      function Random_Searching(Charge_Max : in Float; Missiles_Max : in Positive; Side : in Side_Type) return Weapon_Manager.Vector;
   end Random_Search;
   
   package body Random_Search is                      
      package Bool_Random is new Ada.Numerics.Discrete_Random(Boolean);   
      use Float_Random;
      
      Position_Gen : Generator;

      function Random_Searching(Charge_Max : in Float; Missiles_Max : in Positive; Side : in Side_Type) return Weapon_Manager.Vector is
	 
	 Bool_Gen : Bool_Random.Generator;
	 
	 Weapons : Weapon_Manager.Vector;
	 Missile : Missile_Type;
      begin
	 Reset(Position_Gen);
	 Bool_Random.Reset(Bool_Gen);	 	 
	 for Index in 1..Missiles_Max loop
	    
	    declare
	       
	    begin
	       case Side is
		  
		  when Ouest =>
		     --Text_Io.Put("6 1");
		     if Bool_Random.Random(Bool_Gen) then
			Missile.Position := To_Gps(Random(Position_Gen) * (-180.0), Random(Position_Gen) * (-90.0));
		     else
			Missile.Position := To_Gps(Random(Position_Gen) * (-180.0), Random(Position_Gen) * (90.0));
		     end if;
		     --  loop
		     --     --Text_Io.Put("6 2");
		     --     Ouest_Target_X := Random(Position_Gen);
		     --     exit when ouest_Target_X > 0.5;			   
		     --  end loop;
		     --Text_Io.Put("6 3");
		     if Bool_Random.Random(Bool_Gen) then
			Missile.Target := To_Gps(Random(Position_Gen) * 180.0, Random(Position_Gen) * (-90.0));
		     else
			Missile.Target := To_Gps(Random(Position_Gen) * 180.0, Random(Position_Gen) * (90.0));
		     end if;
		     
		  when Est =>
		     --Text_Io.Put("6 4");
		     if Bool_Random.Random(Bool_Gen) then
			Missile.Position := To_Gps(Random(Position_Gen) * 180.0, Random(Position_Gen) * (-90.0));
		     else
			Missile.Position := To_Gps(Random(Position_Gen) * 180.0, Random(Position_Gen) * (90.0));
		     end if;
		     --  loop
		     --     --Text_Io.Put("6 5");
		     --     est_Target_X := Random(Position_Gen);
		     --     exit when est_Target_X < 0.5;			   
		     --  end loop;	
		     --Text_Io.Put("6 6");
		     if Bool_Random.Random(Bool_Gen) then
			Missile.Target := To_Gps(Random(Position_Gen) * (-180.0), Random(Position_Gen) * (-90.0));
		     else
			Missile.Target := To_Gps(Random(Position_Gen) * (-180.0), Random(Position_Gen) * (90.0));
		     end if;
		     
	       end case;
	       --Text_Io.Put("6 7");
	       Missile.charge := Charge_Type(Charge_Max);
	    end;
	    --Text_Io.Put("6 8");
	    --Print_Missile(Missile);
	    --Text_Io.Put("6 9");
	    Weapon_Manager.Insert(Weapons, Weapon_Manager.Last_Index(Weapons) + 1, Missile, 1);
	       	 
	    --Text_Io.Put("6 13");
	 end loop;
	    
	 
	 
	 
	 
	 
	 
	 
	 return Weapons;
      end Random_Searching;      
   end Random_Search;
   
   

   use Weapon_Manager;
   
   
   task body Wopr is                        
	 
      
      Local_Logname : Logname_Type := ((others => Character'Val(32)));
      
      Term_Address      : Sock_Addr_Type;
      Socket            : Socket_Type;
      Channel           : Stream_access;            
      --Populations_Count : Nation_Index_Type; 
      
      
      
      Algorithm : Algorithm_Access := random_Search.Random_Searching'Access;
      
      Command : Command_Type;
   begin

      loop
	 select
	    accept Login(Hostname : in String; 
			 Logname : in String; 
			 Passwd : in Sha1.Message_Digest;
			 Success : out boolean) do
	       if Hostname'Length /= 0 then
		  Term_Address.Addr := Addresses (Get_Host_By_Name (Hostname));
	       else		  
		  Term_Address.Addr := Addresses (Get_Host_By_Name (Host_Name));
	       end if;
	       Term_Address.Port := 5872;
	       
	       Create_Socket (Socket);
	       
	       Set_Socket_Option
		 (Socket,
		  Socket_Level,
		  (Reuse_Address, True));
	       
	       delay 0.2;
	       begin
		  Connect_Socket (Socket, Term_Address);
		  Channel :=  stream(Socket);
		  Success := True;
		  Command_Type'Output(Channel, Login);
		  Fixed.Move(Logname,  Local_Logname, Error, Left);
		  String'Output(Channel, Local_Logname);
		  SHA1.Message_Digest'Output(Channel, Passwd);		  
		  if boolean'Input(Channel) then
		     Success := True;
		  else
		     Success := False;
		  end if;
	       exception
		  when Gnat.Sockets.Socket_Error =>
		     Success := False;
	       end;
	       
	    end Login;
	 or
	    accept Logout do
	       Close_socket(Socket);
	    end Logout;
	 or
	    accept Get(Wopr : in out Wopr_Type; Success : out Boolean) do
	       	       
	       
	       Command_type'Output(Channel, Wopr_get);
	       Wopr_Type'Output(Channel, Wopr);	       
	       --Text_Io.Put_Line("Getting success");
	       Command := Command_type'input(Channel);
	       --Text_Io.Put_Line("Getting success done");	       
	       case Command is
		  when Wopr_Get =>	       		     
		     Wopr := Wopr_Type'Input(Channel);
		     --Text_Io.Put_Line("Getting Wopr done");
		     Success := True;
		  when others =>
		     Success := False;
	       end case;
	    end Get;
	    
	 or
	    accept Create(Wopr : in out Wopr_Type; 
			  Success : out Boolean) do
	       Command_type'Output(Channel, Wopr_Create);
	       --Wopr.Start_Time := Clock;
               Wopr_Type'Output(Channel, Wopr);	       
	       --Text_Io.Put_Line("Wopr_Create");
               Success := Boolean'Input(Channel);	       
	       if Success then
		  Command_type'Output(Channel, Wopr_get);
		  Wopr_Type'Output(Channel, Wopr);	       
		  --Text_Io.Put_Line("Getting success");
		  Command := Command_type'input(Channel);
		  --Text_Io.Put_Line("Getting success done");	       
		  case Command is
		     when Wopr_Get =>	       		     
			Wopr := Wopr_Type'Input(Channel);
			--Text_Io.Put_Line("Getting Wopr done");
			Success := True;
		     when others =>
			Success := False;
		  end case;
	       end if;
	    end Create;
	       
	 or -- Defcon 1
	    accept Launch(Wopr : in out Wopr_Type; 
			  Success : out Boolean) do
	       Command_Type'Output(Channel, Launch_All);
	       --Text_Io.Put_Line("Norad : launch command");
	       Success := Boolean'Input(Channel);	  
	       --Text_Io.Put_Line("Norad : launch receive success");
	    end Launch;
	 or -- Defcon 2 and 4
	    accept Armament(Wopr : in out Wopr_Type; 
				      Success : out Boolean) do
	       
	       declare
		  Tmp : Weapon_Manager.Vector := Weapon_Manager.Empty_Vector;
	       begin	       
		  if Weapon_Manager.Last_Index(Wopr.Weapons) /= 0 then		  		  
		     for Index in 1..Weapon_Manager.Last_Index(Wopr.Weapons) loop
			declare		  
			   Missile : constant Missile_Type := Weapon_Manager.Element(Wopr.Weapons, Index);
			begin
			   --Text_Io.Put_Line("initialize new missile");
			   
			   if Wopr.Charge - Missile.Charge >= 0.0 then
			      Command_Type'Output(Channel, Missile_Create);
			      Missile_Type'Output(Channel, Missile);			
			      --Text_Io.Put_Line("Add new missile");			   			      
			      Success := Boolean'Input(Channel);
			      if Success then
				 Wopr.Charge :=
				   Wopr.Charge - Missile.Charge;
				 
				 Tmp := Tmp & Missile;
			      else
				 exit;			   
			      end if;			   
			   end if;
			end;
		     end loop;
		     Wopr.Weapons := Tmp;
		  end if;		  
	       end;
	       Success := True;
	    end Armament;
	 or -- Defcon 3
	    accept Enemy_Acquisition(Wopr : in out Wopr_Type;
				     Success : out Boolean) do
	       Command_type'Output(Channel, Enemy_get);
	       if Boolean'Input(Channel) then
		  --Text_Io.Put_Line("Enemy available");
		  Wopr.Enemy := Weapon_Manager.Vector'Input(Channel);
		  --Text_Io.Put_Line("Enemy loding done.");
	       end if;		 
	       Success := True;
	    end Enemy_Acquisition;
	 or -- Defcon 5	    
	    accept Target_Search(Wopr : in out Wopr_Type; 
				 Success : out Boolean;
				 Charge_Max : in Charge_Type;
				 Target_Max : in Positive) do
	       Success := True;
	       Wopr.Weapons := Algorithm(Float(Charge_Max), Target_Max, Wopr.side);	       
	    end Target_Search;
	    
	 or
	    accept Set_Algorithm(Algo : in Algo_Type) do
	       case Algo is
		  when Linear =>
		     Algorithm := Linear_Search.Linear_Searching'Access;
		  --  when Genetic =>
		  --     Algorithm := Genetic_Search.Random_Ant_Searching'Access;
		  when Random =>
		     Algorithm := Random_Search.Random_Searching'Access;
	       end case;
	    end Set_Algorithm;
	 end select;
      end loop;
   end Wopr;
   
   
end Warborg.Norad;
