with Gnat.Sha1;
use Gnat;
package Warborg.Norad is      
   
   type Algo_Type is (Linear, Random);
   
   task Wopr is      
      entry Login(Hostname : in String; 
   		  Logname : in String; 
   		  Passwd : in Sha1.Message_Digest;
   		  Success : out boolean);
      
      entry Logout;
      
      entry Get(Wopr : in out Wopr_Type; 
		Success : out Boolean);
      
      entry Create(Wopr : in out Wopr_Type; 
		   Success : out Boolean);
      
      entry Launch(Wopr : in out Wopr_Type; 
		   Success : out Boolean);
      
      entry Target_Search(Wopr : in out Wopr_Type; 
			  Success : out Boolean;
			  Charge_Max : in Charge_Type;
			  Target_Max : in Positive);
      
      entry Armament(Wopr : in out Wopr_Type; 
			       Success : out Boolean);
      
      entry Enemy_Acquisition(Wopr : in out Wopr_Type;
			      Success : out Boolean);
      
      
      entry Set_Algorithm(Algo : in Algo_Type);
   end Wopr;
   
end Warborg.Norad;
